package com.jh.boot.attachment;

import java.util.Collections;
import java.util.List;

import org.springframework.stereotype.Repository;

import com.jh.boot.jpa.AbstractHibernateRepository;
import com.jh.boot.web.list.PagingInfo;

/**
 * The Class AttachmentRepository.
 */
@Repository
public class AttachmentRepository extends AbstractHibernateRepository {

	
	/**
	 * Find for unit id and object.
	 *
	 * @param unitId the unit id
	 * @param objectType the object type
	 * @param objectId the object id
	 * @param paging the paging
	 * @return the page
	 */
	public List<Attachment> findForUnitIdAndObject(Long unitId, String objectType, Long objectId, PagingInfo paging) {
//		Criteria c = criteria(Attachment.class);
		
//		c.add(Restrictions.eq("unitId", unitId));
//		c.add(Restrictions.eq("objectType", objectType));
//		c.add(Restrictions.eq("objectId", objectId));
		
//		c.addOrder(Order.desc("uploaded"));
//		c.addOrder(Order.desc("name"));
		
//		return pagedResult(c, paging);
		return Collections.emptyList();
	}

	/**
	 * Find for unit id and object.
	 *
	 * @param unitId the unit id
	 * @param objectType the object type
	 * @param objectId the object id
	 * @return the list
	 */
	public List<Attachment> findForUnitIdAndObject(Long unitId, String objectType, Long objectId) {
		return Collections.emptyList();
	}

	
	/**
	 * Find for unit id and id.
	 *
	 * @param unitId the unit id
	 * @param attachmentId the attachment id
	 * @return the attachment
	 */
	public Attachment findForUnitIdAndId(Long unitId, Long attachmentId) {
//		Criteria c = criteria(Attachment.class);
//		
//		c.add(Restrictions.eq("unitId", unitId));
//		c.add(Restrictions.idEq(attachmentId));
//		
//		return (Attachment) c.uniqueResult();
		return null;
	}

	
    /**
     * Rename.
     *
     * @param unitId the unit id
     * @param objectType the object type
     * @param objectId the object id
     * @param attachmentId the attachment id
     * @param name the name
     */
    public void rename(Long unitId, String objectType, Long objectId, Long attachmentId, String name) {
        Attachment a = findForUnitIdAndId(unitId, attachmentId);
        a.setName(name);
    }

	public Attachment findById(Long id) {
		return entityManager.find(Attachment.class, id);
	}
	
	
}
