package com.jh.boot.attachment;

import java.io.InputStream;
import java.util.List;

public interface AttachmentService {

    Attachment saveAttachment(Attachment attachment, InputStream content);

    Attachment saveAttachment(Attachment attachment);

    List<Attachment> fetchAttachments(Long unitId, String objectType, Long objectId);

    Attachment fetchAttachment(Long attachmentId);

    InputStream fetchAttachmentBody(Attachment attachment);

    void deleteAttachment(Long attachmentId);

}
