package com.jh.boot.security.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import com.jh.boot.jpa.AbstractIdEntity;

@Entity
@Table(name = "RESET_PASSWORD_TOKEN")
public class ResetPasswordToken extends AbstractIdEntity {

	private static final long serialVersionUID = 1L;

	@Column(name = "LOGIN")
	private String login;
	
	@Column(name = "CREATED")
	private Date created;
	
	@Column(name = "TOKEN")
	private String token;
	
	@Column(name = "USED")
	private Boolean used;
	

	public ResetPasswordToken() {
		super();
	}

	public ResetPasswordToken(String login, Date created, String token) {
		super();
		this.login = login;
		this.created = created;
		this.token = token;
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public Date getCreated() {
		return created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	public String getToken() {
		return token;
	}

	public void setToken(String token) {
		this.token = token;
	}

	public Boolean getUsed() {
		return used;
	}

	public void setUsed(Boolean used) {
		this.used = used;
	}
	
	
	
}
