/*
 * Created on 30. 10. 2016 7:32:25
 *
 */
package com.jh.boot.web.list;

/**
 * The Enum SortTrend.
 *
 * @author Jan Hrabal
 */
public enum SortTrend {

	/** The ascending. */
	ASCENDING("asc"),
	/** The descending. */
	DESCENDING("desc");

	private String trend;

	private SortTrend(String trend) {
		this.trend = trend;
	}

	public String getTrend() {
		return trend;
	}

	@Override
	public String toString() {
		return trend;
	}
	
	
	public static SortTrend parse(String s) {
		for (SortTrend st : values()) {
			if (st.trend.equalsIgnoreCase(s) || st.name().equalsIgnoreCase(s)) {
				return st;
			}
		}
		return null;
	}
	
	
}
